Library UserGraph;


uses WinProcs,
  WinTypes,
  SysUtils,
  Controls,
  Forms,
  Classes,
  Graphics,
  StdCtrls,
  UserGraphForm in 'UserGraphForm.pas' {Form1};

type
  PParameterStruct=^TParameterStruct;
  TParameterStruct=packed record
    NuE : Byte;                           {Anzahl reeller Zahlenwerte}
    NuI : Byte;                           {Anzahl ganzer Zahlenwerte}
    NuB : Byte;                           {Anzahl Schalter}
    E:Array[0..31] of Extended;           {reelle Zahlenwerte}
    I:Array[0..31] of Integer;            {ganze Zahlenwerte}
    B:Array[0..31] of Byte;               {Schalter}
    D:Array[0..255] of char;              {event. Dateiname fr weitere Daten.}
    EMin:Array[0..31] of Extended;        {untere Eingabegrenze fr jeden reellen Zahlenwert}
    EMax:Array[0..31] of Extended;        {obere Eingabegrenze fr jeden rellen Zahlenwert}
    IMin:Array[0..31] of Integer;         {untere Eingabegrenze fr jeden ganzzahligen Zahlenwert}
    IMax:Array[0..31] of Integer;         {obere Eingabegrenze fr jeden ganzzahligen Zahlenwert}
    NaE : Array[0..31,0..40] of char;     {Namen der reellen Zahlenwerten}
    NaI : Array[0..31,0..40] of char;     {Namen der ganzen Zahlenwerten}
    NaB : Array[0..31,0..40] of char;     {Namen der Schalter}
    UserDataPtr: TForm1;                  {Zeiger auf weitere Blockvariablen}
    ParentPtr: Pointer;                   {Zeiger auf User-DLL-Block}
    ParentHWnd: HWnd;                     {Handle des User-DLL-Blocks}
    ParentName: PChar;                    {Name des User-DLL-Blocks}
    UserHWindow: HWnd;                    {Benutzerdef. Fensterhandle, z. B. fr Ausgabefenster}
    DataFile: text;                       {Textdatei fr universelle Zwecke}
  end;

  PDialogEnableStruct=^TDialogEnableStruct;
  TDialogEnablestruct=packed record
    AllowE: Longint;                      { Soll die Eingabe eines Wertes   }
    AllowI: Longint;                      { un-/zulssig sein so ist das Bit}
    AllowB: Longint;                      { des Allow?-Feldes 0 bzw. 1}
    AllowD: Byte;
  end;

  PNumberOfInputsOutputs=^TNumberOfInputsOutputs;
  TNumberOfInputsOutputs=packed record
    Inputs :Byte;                         {Anzahl Eingnge}
    Outputs:Byte;                         {Anzahl Ausgnge}
    NameI : Array[0..49,0..40] of char;
    NameO : Array[0..49,0..40] of char;
  end;

  PInputArray = ^TInputArray;
  TInputArray = packed array[1..10] of extended;
  POutputArray = ^TOutputArray;
  TOutputArray = packed array[1..10] of extended;


procedure GetParameterStruct(D:PParameterStruct);export stdcall;
begin
  {Anzahl der Parameter}
  D^.NuE := 0;
  D^.NuI := 0;
  D^.NuB := 0;
end;

procedure GetDialogEnableStruct(D:PDialogEnableStruct;D2:PParameterStruct);export stdcall;
begin
  {Alle Dialogelemente sollen jederzeit zugnglich sein!}
  D^.AllowE:=$FFFFFFFF;
  D^.AllowB:=$FFFFFFFF;
  D^.AllowI:=$FFFFFFFF;
  D^.AllowD:= 1;
end;

procedure GetNumberOfInputsOutputs(D:PNumberOfInputsOutputs);export stdcall;
begin
  D^.Inputs := 0;
  D^.Outputs := 0;
end;

function CanSimulateDLL(D:PParameterStruct):Integer; export stdcall;
begin
  CanSimulateDLL := 1;
end;

procedure SimulateDLL(T:Extended;D:PParameterStruct;Inputs:PInputArray;Outputs:POutputArray);export stdcall;
begin
end;

procedure InitSimulationDLL(D:PParameterStruct;Inputs:PInputArray;Outputs:POutputArray);export stdcall;
var i, j: integer;
begin
  D^.UserDataPtr.Caption := StrPas(D^.ParentName);
  SimulateDLL(0, D, Inputs, Outputs);
end;

procedure EndSimulationDLL;export stdcall;
begin
end;

procedure InitUserDLL(D: PParameterStruct); export stdcall;
begin
  Application.Handle := D^.ParentHWnd;
  D^.UserDataPtr := TForm1.Create(Application);
  D^.UserDataPtr.Show;
end;

procedure DisposeUserDLL(D: PParameterStruct); export stdcall;
begin
  Application.Handle := 0;
  D^.UserDataPtr.Free;
end;

function GetDLLName: PChar; export stdcall;
begin
  GetDLLName := 'Anwender-Grafik (BMP oder WMF-Format)';
end;

procedure ShowWindowDLL(D: PParameterstruct); export stdcall;
begin
  ShowWindow(D^.UserDataPtr.Handle, sw_ShowNormal);
end;

procedure HideWindowDLL(D: PParameterstruct); export stdcall;
begin
  ShowWindow(D^.UserDataPtr.Handle, sw_Minimize);
end;

Procedure WriteToFile(AFileHandle:word; D: PParameterStruct); export stdcall;
var s: array[0..1000] of char;
begin
  with D^.UserDataPtr do begin
    StrPCopy(s, Filename + #13#10);
    _lWrite(AFileHandle, s, StrLen(s));
    StrPCopy(s, IntToStr(Left) + #13#10);
    _lWrite(AFileHandle, s, StrLen(s));
    StrPCopy(s, IntToStr(Top) + #13#10);
    _lWrite(AFileHandle, s, StrLen(s));
    StrPCopy(s, IntToStr(Width) + #13#10);
    _lWrite(AFileHandle, s, StrLen(s));
    StrPCopy(s, IntToStr(Height) + #13#10);
    _lWrite(AFileHandle, s, StrLen(s));
  end;
end;

Procedure ReadFromFile(AFileHandle:word; D: PParameterStruct); export stdcall;
var i: integer;
    s: array[0..1000] of char;
procedure ReadOneLine(FHandle:Word; Aps :PChar);
var i  : Integer;
begin
  i:=0;
  _lRead(FHandle,@Aps[i],1);
  repeat
    inc(i);
    _lRead(FHandle,@Aps[i],1);
  until (Aps[i-1]=#13) and (Aps[i]=#10);
  Aps[i-1]:=#0;
end;
begin
  with D^.UserDataPtr do begin
    ReadOneLine(AFileHandle, s);
    Filename := StrPas(s);
    UpdateImage;
    ReadOneLine(AFileHandle, s);
    Left := StrToInt(StrPas(s));
    ReadOneLine(AFileHandle, s);
    Top := StrToInt(StrPas(s));
    ReadOneLine(AFileHandle, s);
    Width := StrToInt(StrPas(s));
    ReadOneLine(AFileHandle, s);
    Height := StrToInt(StrPas(s));
  end;
end;

function NumberOfLinesInSystemFile: integer; export stdcall;
begin
  NumberOfLinesInSystemFile := 5;
end;

procedure IsUserDLL32; export stdcall;
begin
end;

{Exportieren der notwendigen Funktionen und Prozeduren }
exports
  GetParameterStruct,
  GetDialogEnableStruct,
  GetNumberOfInputsOutputs,
  CanSimulateDLL,
  InitSimulationDLL,
  SimulateDLL,
  InitUserDLL,
  DisposeUserDLL,
  EndSimulationDLL,
  GetDLLName,
  ShowWindowDLL,
  HideWindowDLL,
  ReadFromFile,
  WriteToFile,
  NumberOfLinesInSystemFile,
  IsUserDLL32;


begin
  {Weitere Initialisierung der DLL}
end.
